# VIPPS LOGIN FOR DRUPAL

## TABLE OF CONTENTS

* [ INTRODUCTION ](#introduction)
* [ REQUIREMENTS ](#requirements)
* [ GETTING STARTED ](#getting-started)
* [ INSTALLATION ](#installation)
* [ CONFIGURATION](#configuration)
* [ HOW IT WORKS ](#how-it-works)
* [ FREQUENTLY ASKED QUESTIONS ](#frequently-asked-questions)

## INTRODUCTION
*This project is based on [Social API](https://www.drupal.org/project/social_api) and [Social Auth](https://www.drupal.org/project/social_auth).

The module lets you login to Drupal using the Vipps app. It’s a secure and
reliable way to handle user authentication.

The module adds two things:

* An alternative URL for login: /user/login/vipps

* A button that can be positioned as a block or as part of the standard login
  form

<img src="https://www.drupal.org/files/social_auth_vipps_login.png" alt="Login page with social auth block" width="300" height="auto">

See how it works in this video:
[![See how it works in this video](https://i.imgur.com/7OmBJjM.png)](https://player.vimeo.com/video/419856996)

## REQUIREMENTS
* Drupal 8.x
* Composer
* [Social API]([https://www.drupal.org/project/](https://www.drupal.org/project/advancedqueue)social_api)
* [Social Auth]([https://www.drupal.org/project/](https://www.drupal.org/project/commerce)social_auth)
* Working Vipps account (see below)

## GETTING STARTED

* Sign up to use ([Vipps på Nett](https://www.vipps.no/signup/vippspanett/))
* After 1-2 days you will get an email with login details to Vipps Developer
  Portal. This is where you can retrieve the API credentials used to configure
  the module in Drupal.
* Proceed to "Installation" below

### INSTALLATION
* Install dependencies
* Install the module

If you install the module using Composer, the dependencies will be added
automatically:

`composer require "drupal/social_auth_vipps"`


### CONFIGURATION

* Add your Vipps project OAuth information in
Configuration » User Authentication » Vipps.

<img src="https://www.drupal.org/files/social_auth_vipps_config.png" alt="Social auth vipps module configuration" width="400" height="auto">

* Place a Social Auth Login block in Structure » Block Layout.

<img src="https://www.drupal.org/files/social_auth_vipps_block.png" alt="Social auth block configuration" width="400" height="auto">

* OR: Click “Show in login form”

* If you already have a Social Auth Login block on the site, rebuild the cache


## HOW IT WORKS
The user can click on the Vipps logo in the Social Auth Login block. You can
also add a button or link anywhere on the site that points to /user/login/vipps,
so theming and customizing the button or link is very easy.

After Vipps has returned the user to your site, the module compares the user id
or email address provided by Vipps. If the user has previously registered using
Vipps or your site already has an account with the same email address, the user
is logged in. If not, a new user account is created. Also, a Vipps account can
be associated with an authenticated user by matching the email address.

## FREQUENTLY ASKED QUESTIONS

### HOW CAN I GET HELP WITH THE MODULE?
First, check out the documentation pages for the module on Drupal.org. If you still have issues, please create an issue in the [issue queue](https://www.drupal.org/project/issues/social_auth_vipps) for the module. Before posting a support request, please check the Recent Log entries at admin/reports/dblog.

### WHERE CAN I USE VIPPS?
Vipps is only available in Norway at the moment and only users who have the
Vipps app installed will be able to log in with Vipps.
